<template>
    <div class="TextInput" :class="{ 'has-error': !!errorMessage, success: meta.valid }">
        <label v-if="!!label" class="block mb-2 text-sm font-medium text-gray-900 " :for="name">{{ label }}</label>
        <input
            class="bg-gray-50 border h-[46px] border-gray-300 text-gray-900 text-sm rounded-[5px] focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 "
            :name="name" :id="name" :type="type" :value="inputValue" :placeholder="placeholder" @input="onChange"
            @blur="handleBlur" v-bind="$attrs" :class="{ 'cursor-not-allowed': disabled }" :disabled="disabled" />

        <p class="text-danger text-[13px] first-letter:uppercase" v-show="errorMessage || isInvalid">
            {{ errorMessage || errorMessageCustom }}
        </p>
    </div>
</template>

<script>
import { toRef } from "vue";
import { useField } from "vee-validate";

export default {
    name: "VInput",
    props: {
        type: {
            type: String,
            default: "text",
        },
        value: {
            type: String,
            default: "",
        },
        name: {
            type: String,
            required: true,
        },
        label: {
            type: String,
            default: "",
        },
        errorMessageCustom: {
            type: String,
            default: "",
        },
        placeholder: {
            type: String,
            default: "",
        },
        disabled: {
            type: Boolean,
            default: false
        }
    },
    emits: ['change'],
    setup(props, { emit }) {
        const name = toRef(props, "name");

        const {
            value: inputValue,
            errorMessage,
            handleBlur,
            handleChange,
            meta,
        } = useField(name, undefined, {
            initialValue: props.value,
        });

        const onChange = (value) => {
            handleChange(value);
            console.log(value.target.value);
            emit('change', value.target.value);
        }

        return {
            handleChange,
            handleBlur,
            errorMessage,
            inputValue,
            meta,
            onChange
        };
    },
};
</script>